<!--suppress JSIncompatibleTypesComparison -->

<script setup lang="ts">
import { PhArrowLeft, PhArrowRight, PhCheck, PhPencil } from '@phosphor-icons/vue';
import { Alert, Input, Modal, Textarea, Toast } from '@distromade/distro-ui';

import { useRoute, useRouter, useHead, computed, ref, watch } from '#imports';
import * as API from '~/utils/api';
import { numberWithCommas } from '~/utils';
import { useCartStore, useContentStore } from '~/stores';
import { useOneProduct } from '~/composables';
import type { CartItem, ProductVariant, SubCategory, VariantCategory } from '~/utils/types';

const contentStore = useContentStore();
contentStore.setContent(null);

const cartStore = useCartStore();
const router = useRouter();
const route = useRoute();
const { product, pending, error } = await useOneProduct(route.params.id as string);

const selectedVariant = ref<ProductVariant | null>(null);
const thumbnailIndex = ref(0);
const quantity = ref(1);
const thumbnail = ref<string>('');
const reviewModalOpen = ref<boolean>(false);
const successfulReview = ref<boolean>(false);
const buttonText = ref<string>('');
const reviewOrderId = ref<string>('');
const reviewStars = ref<number>(5);
const reviewValue = ref<string>('');

const productReviewError = ref<string | null>(null);

const reviewModalActions = {
  primary: {
    text: 'Submit review',
  },
};

if (product.value) {
  setInitialVariant();
  setThumbnail();
  setButtonText();
}

const asyncError = computed(() => {
  if (error.value) {
    const { message, statusCode } = error.value;
    return { message, statusCode };
  }
});
const productPrice = computed(() => {
  const price = product.value.price;
  if (price === null) {
    return 'Not available';
  }
  return `$${numberWithCommas(Number(price) * quantity.value)}`;
});

function setInitialVariant() {
  if (!route.query.variantId && product.value?.variants?.length) {
    selectedVariant.value = product.value.variants[0];
    setVariantSelections(selectedVariant.value, product.value.variantCategories);
    router.replace({ query: { ...route.query, variantId: selectedVariant.value.id } });
  } else if (route.query.variantId) {
    getSelectedVariantById(route.query.variantId);
  }
}

async function selectVariant(subCategory: SubCategory, subCategories: SubCategory[]) {
  subCategories.forEach((a: any) => {
    a.selected = false;
  });
  subCategory.selected = true;

  selectedVariant.value = await getSelectedVariant(
    product.value.variants,
    product.value.variantCategories,
  );

  if (selectedVariant.value) {
    await router.push({ query: { variantId: selectedVariant.value.id } });
  } else {
    await router.replace({ query: undefined });
  }
}

async function getSelectedVariantById(id: any) {
  selectedVariant.value = product.value.variants.find((variant) => variant.id === id) ?? null;
  setThumbnail();
  if (selectedVariant.value) {
    await setVariantSelections(selectedVariant.value, product.value.variantCategories);
  }
}

async function getSelectedVariant(
  variants: ProductVariant[],
  variantCategories: VariantCategory[],
) {
  const selectedVariant = variants.find((variant) => {
    return variantCategories.every((category) => {
      const selectedSubcategories = category.subCategories
        .filter((subCategory) => subCategory.selected)
        .map((subCategory) => subCategory.name);

      return selectedSubcategories.includes(
        variant.variantCategories[category.name.toLowerCase()],
      );
    });
  });
  return selectedVariant ?? null;
}

function getVariantThumbnailIndex(product: any, thumbnail: any) {
  return product.images.findIndex((image: any) => image.url === thumbnail);
}

function setThumbnail() {
  if (selectedVariant.value && selectedVariant.value.thumbnail) {
    thumbnail.value = selectedVariant.value.thumbnail;
    thumbnailIndex.value = getVariantThumbnailIndex(product.value, thumbnail.value);
  } else if (product.value.thumbnail) {
    thumbnail.value = product.value.thumbnail;
    thumbnailIndex.value = getVariantThumbnailIndex(product.value, product.value.thumbnail);
  } else {
    thumbnail.value = product.value.images[0].url;
  }
}

async function setVariantSelections(
  singleObject: ProductVariant,
  selectedVariants: VariantCategory[],
) {
  if (singleObject) {
    Object.entries(singleObject.variantCategories).forEach(([category, value]) => {
      const matchingVariant = selectedVariants.find(
        (variant: any) => variant.name.toLowerCase() === category.toLowerCase(),
      );
      if (matchingVariant) {
        matchingVariant.subCategories.forEach((subCategory: any) => {
          subCategory.selected =
            subCategory.name.toLowerCase() === String(value).toLowerCase();
        });
      }
    });
  }
}

function updateThumbnail(url: any) {
  thumbnailIndex.value = getVariantThumbnailIndex(product.value, url);
  thumbnail.value = url;
}

function imageMatchesThumbnail(url: any) {
  return url === thumbnail.value;
}

function openReviewModal() {
  reviewModalOpen.value = true;
}

function prevImage() {
  if (thumbnailIndex.value > 0) {
    thumbnailIndex.value -= 1;
    thumbnail.value = product.value.images[thumbnailIndex.value].url;
  }
}

function nextImage() {
  if (thumbnailIndex.value < product.value.images.length - 1) {
    thumbnailIndex.value += 1;
    thumbnail.value = product.value.images[thumbnailIndex.value].url;
  }
}

async function submitReview() {
  const today = new Date();
  const review = {
    created: today.toISOString(),
    stars: reviewStars.value,
    orderId: reviewOrderId.value,
    review: reviewValue.value,
    productId: product.value.id,
  };

  const response = await API.sendProductReview(review);

  if (response.success) {
    // Handle successful response
    console.log('Review submitted successfully:', response.data);
    reviewModalOpen.value = false;
    successfulReview.value = true;
    setTimeout(() => {
      successfulReview.value = false;
    }, 3000);
  } else {
    if (response?.error?.includes('404')) {
      productReviewError.value = 'No order with that ID exists';
      // Specific handling for 404 error
    }
  }
}

const cantAddToCart = computed(() => {
  const hasVariants = product.value.variants && product.value.variants.length > 0;
  const { inventory, price } = product.value;

  if (hasVariants) {
    const variantAvailable =
      selectedVariant.value &&
      selectedVariant.value.price !== null &&
      (selectedVariant.value.inventory.madeToOrder ||
        selectedVariant.value.inventory.inStock > 0);
    return !variantAvailable || addedToCart(selectedVariant.value, product.value.id);
  } else {
    const productAvailable =
      price !== null && (inventory.madeToOrder || inventory.inStock > 0);
    return !productAvailable || addedToCart(null, product.value.id);
  }
});

function addedToCart(selectedVariant: ProductVariant | null, productId: string) {
  // Check if the product has variants
  const productHasVariants = product.value.variants && product.value.variants.length > 0;

  // If the product has variants and a selectedVariant exists with a non-null price
  if (productHasVariants && selectedVariant && selectedVariant.price !== null) {
    return cartStore.cart.some((el) => el.id === selectedVariant.id);
  }

  // If the product doesn't have variants, check the product itself in the cart
  // Adjust this line if the cart structure for products without variants uses a different field for the product ID
  if (!productHasVariants) {
    return cartStore.cart.some((el) => el.id === productId);
  }

  return false;
}

function setButtonText() {
  const hasVariants = product.value.variants && product.value.variants.length > 0;
  const { inventory, price } = product.value;

  if (addedToCart(selectedVariant.value, product.value.id)) {
    buttonText.value = 'Added to Bag';
    return;
  }

  if (hasVariants) {
    const variantAvailable =
      selectedVariant.value &&
      selectedVariant.value.price !== null &&
      (selectedVariant.value.inventory.madeToOrder ||
        selectedVariant.value.inventory.inStock > 0);
    buttonText.value = variantAvailable ? 'Add to Bag' : 'Option not available';
  } else {
    const productAvailable =
      price !== null && (inventory.madeToOrder || inventory.inStock > 0);
    buttonText.value = productAvailable ? 'Add to Bag' : 'Option not available';
  }
}

function addToCart() {
  // Only proceed if the product has a valid price
  let item;

  // If there's a selected variant and it has a valid price
  if (selectedVariant.value && selectedVariant.value.price !== null) {
    item = {
      quantity: quantity.value,
      isVariant: true,
      productName: product.value.name,
      ...selectedVariant.value,
    };
  }
  // If no valid variant, but the product itself is valid and either made to order or in stock
  else if (
    !selectedVariant.value &&
    (product.value.inventory.madeToOrder || product.value.inventory.inStock > 0)
  ) {
    item = {
      quantity: quantity.value,
      ...product.value,
    };
  } else {
    // If neither condition is met, do not add to cart
    return;
  }

  // Add the item to the cart
  cartStore.addToCart(item as unknown as CartItem);

  // Reset quantity and update button text
  quantity.value = 1;
  setButtonText();
}

const averageStars = computed(() => {
  const totalReviews = product.value.reviews.length;
  if (totalReviews === 0) return 0;

  const totalStars = product.value.reviews.reduce((sum, review) => sum + review.stars, 0);
  return Math.ceil(totalStars / totalReviews);
});

watch(
  () => route.query.variantId,
  (newId) => {
    if (newId) getSelectedVariantById(newId);
    setButtonText();
  },
);

const pageTitle = computed(() => {
  return selectedVariant.value?.name || product.value?.name || 'Product';
});

useHead({ title: pageTitle });
</script>

<template>
  <section class="content">
    <Toast
      v-if="successfulReview"
      text="Review successfully submitted"
      style="
        font-size: 14px;
        font-family:
          DM Sans,
          serif;
      "
    />
    <Modal
      title="Leave a review"
      v-if="reviewModalOpen"
      :actions="reviewModalActions"
      @close="reviewModalOpen = false"
      @primary="submitReview"
    >
      <Alert v-if="productReviewError" variant="danger" :text="productReviewError" />
      <StarSelector v-model:rating="reviewStars" />
      <Input
        class="mt-4"
        label="Order ID"
        name="order-id"
        id="order-id"
        v-model="reviewOrderId"
        required
      />
      <Textarea
        class="mt-3"
        label="Review"
        name="review-value"
        id="review-value"
        v-model="reviewValue"
        required
      />
    </Modal>

    <section v-if="pending">
      <Loading class="h-80 w-full" />
    </section>

    <section
      v-else-if="asyncError"
      class="w-full flex justify-center flex-col items-center mt-12"
    >
      <img
        :src="asyncError.statusCode === 404 ? '/not-found.svg' : '/unexpected-error.svg'"
        :width="200"
        :height="132"
        alt=""
      />
      <p class="text-xl mt-6">{{ asyncError.message }}</p>
    </section>

    <section v-else-if="!pending && product" class="product-page">
      <section>
        <div class="product-image-container relative">
          <!-- Image with descriptive alt text -->
          <img
            v-if="thumbnail"
            class="product-image"
            :src="thumbnail"
            :alt="product.name + ' thumbnail'"
          />
          <Loading v-else class="h-80" />

          <div class="bg-white flex w-full">
            <div class="w-1/2 flex justify-center">
              <!-- Arrow with accessible name via aria-label -->
              <Button
                v-if="thumbnailIndex > 0"
                class="arrow"
                @click="prevImage()"
                aria-label="Previous Image"
              >
                <PhArrowLeft :size="20" />
              </Button>
            </div>
            <div class="w-1/2 flex justify-center">
              <Button
                v-if="thumbnailIndex < product.images.length - 1"
                class="arrow"
                @click="nextImage()"
                aria-label="Next Image"
              >
                <PhArrowRight :size="20" />
              </Button>
            </div>
          </div>
        </div>

        <div class="thumbnails">
          <div
            v-for="image in product.images"
            class="thumbnail"
            :class="{ selected: imageMatchesThumbnail(image.url) }"
            :role="'button'"
            tabindex="0"
            @click="updateThumbnail(image.url)"
            @keydown.enter="updateThumbnail(image.url)"
            :aria-label="'Select image ' + (product.images.indexOf(image) + 1)"
          >
            <img
              :src="image.url"
              :alt="product.name + ' image ' + (product.images.indexOf(image) + 1)"
            />
          </div>
        </div>
      </section>

      <section>
        <h1 class="leading-none">{{ product.name }}</h1>
        <template v-if="product.reviews.length">
          <NuxtLink to="#reviews-section" class="flex mt-2">
            <!--suppress JSUnusedLocalSymbols -->
            <img v-for="number in averageStars" src="/img/star-filled.svg" alt="Star" />
            <p class="ml-2">({{ product.reviews.length }})</p>
          </NuxtLink>
        </template>
        <p v-if="selectedVariant" class="text-lg mt-4">${{ selectedVariant.price }}</p>
        <p v-else class="text-lg mt-4">{{ productPrice }}</p>
        <div v-if="product.variants" class="product-variant-selectors">
          <div v-for="variantCategory in product.variantCategories" class="mt-5">
            <label :for="'variant-subcategories-' + variantCategory.name">
              {{ variantCategory.name }}
            </label>
            <div
              id="'variant-subcategories-' + variantCategory.name"
              class="flex flex-wrap gap-2 mt-2"
            >
              <Button
                v-for="subCategory in variantCategory.subCategories"
                class="variant-selector whitespace-nowrap"
                :class="{ selected: subCategory.selected }"
                @click="selectVariant(subCategory, variantCategory.subCategories)"
                :aria-pressed="subCategory.selected ?? false"
              >
                {{ subCategory.name }}
              </Button>
            </div>
          </div>
        </div>

        <div class="mt-8">
          <label for="quantity">Quantity</label>
          <QuantitySelector v-model="quantity" />
        </div>

        <Button
          class="mt-5"
          :text="buttonText"
          variant="primary large w-full"
          @click="addToCart"
          :disabled="cantAddToCart"
        />
        <p class="mt-8 whitespace-pre-wrap">{{ product.description }}</p>
      </section>
    </section>
    <section id="reviews-section w-full" class="mt-20">
      <div class="flex w-full items-center justify-between mb-3">
        <h3 class="flex items-center">
          Verified Reviews
          <PhCheck :size="20" color="green" class="ml-2" />
        </h3>
        <Button text="Write a review" variant="secondary" @click="openReviewModal">
          <template #iconLeft>
            <PhPencil :size="20" class="mr-2" />
          </template>
        </Button>
      </div>
      <div v-if="product.reviews.length" class="grid grid-cols-cart gap-5">
        <ProductReview v-for="review in product.reviews" :review="review" />
      </div>
      <div
        class="p-10 shadow-md rounded-md text-center h-[240px] flex items-center justify-center"
        v-else
      >
        <p>No reviews yet</p>
      </div>
    </section>
  </section>
</template>
